#!/bin/sh

#The idea of using udev and at to initiate 3G ppp connection per SIM came to me 
#(louigi600 at yahoo dot com) one sleepless night. You can do whatever 
#you want with it as long as:
#1) you do not claim the intellectual idea
#2) you tell me ho you modified or added to the idea
#3) I'll be more incline in forgiving 1 and 2 if you donate something to the
#project

DEBUG=0
PATH=/bin:/usr/bin:/sbin:/usr/sbin

LOGGER="logger -p local0.notice -t pppdhelper"

COMMAND=$1
SYSPATH=/sys${DEVPATH} 
export DEBUG LOGGER COMMAND SYSPATH

start_pppd ()
{ [ $DEBUG -eq 1 ] &&  env >> /tmp/startenv
  DEVICE=/dev/$(basename $SYSPATH)
#  [ "$SUBSYSTEM" != "tty" ] && exit 0
  if [ -L ${SYSPATH}/subsystem ]
  then
    [ $DEBUG -eq 1 ] && $LOGGER "Examining $DEVICE"
    PARENT_SYSDEVPATH=$SYSPATH
    while [ -n "$PARENT_SYSDEVPATH" ] && [ ! -f ${PARENT_SYSDEVPATH}/idProduct ]
    do
      PARENT_SYSDEVPATH=$(dirname $PARENT_SYSDEVPATH)
#      [ $DEBUG -eq 1 ] && $LOGGER "${DEVICE}:PARENT_SYSDEVPATH: browsing $PARENT_SYSDEVPATH"
    done
     
    PRODUCT=$(cat ${PARENT_SYSDEVPATH}/idProduct)
    VENDOR=$(cat ${PARENT_SYSDEVPATH}/idVendor)
#    [ $DEBUG -eq 1 ] && $LOGGER "DONE: PARENT_SYSDEVPATH $PARENT_SYSDEVPATH"
#    [ $DEBUG -eq 1 ] && $LOGGER "PRODUCT: $PRODUCT VENDOR: $VENDOR"
     
    IFACENUM_PATH=$SYSPATH
#    [ $DEBUG -eq 1 ] && $LOGGER "${DEVICE}:IFACENUM_PATH: $IFACENUM_PATH"
    while [ -n "$IFACENUM_PATH" ] && [ ! -f ${IFACENUM_PATH}/bInterfaceNumber ]
    do
      IFACENUM_PATH=$(dirname $IFACENUM_PATH)
#      [ $DEBUG -eq 1 ] && $LOGGER "${DEVICE}:IFACENUM_PATH: $IFACENUM_PATH"
    done
    IFACENUM=$(cat ${IFACENUM_PATH}/bInterfaceNumber)
    [ $DEBUG -eq 1 ] && $LOGGER "${DEVICE}:IFACENUM: $IFACENUM PRODUCT: $PRODUCT VENDOR: $VENDOR"
     
#    export PRODUCT VENDOR IFACENUM DEVICE
     
    if [ "$IFACENUM" = "00" ]
    then
      if [ -s /var/run/atd.pid ]
      then
        $LOGGER "$COMMAND at job for isp_ppp on $DEVICE"
        leds -b 200:50 orange &
        echo "/usr/sbin/isp_ppp $DEVICE" |at -q t "now"
         
        if [ $DEBUG -eq 1 ]
        then
          ATJOB=$(basename $(ls -lrt /var/spool/atjobs/t* |tail -1 |awk '{print $NF}'))
          [ -f /var/spool/atjobs/$ATJOB ] && cp /var/spool/atjobs/$ATJOB /tmp/$ATJOB
        fi
      else
        mkdir -p /dev/runme
        echo "#!/bin/sh 
PATH=/bin:/usr/bin:/sbin:/usr/sbin ; export PATH
leds -b 200:50 orange &
sleep 10
logger \"$COMMAND isp_ppp $DEVICE job picked up by rc.local\"
/usr/sbin/isp_ppp $DEVICE
" > /dev/runme/ppp
        chmod 700 /dev/runme/ppp
      fi
    fi
  else
    [ $DEBUG -eq 1 ] && $LOGGER "Failed $COMMAND $DEVICE ${VENDOR}:$PRODUCT ${SYSPATH} device not found: $IFACENUM"
    [ $DEBUG -eq 1 ] &&  env >> /tmp/startenv
  fi
}

stop_pppd ()
{ [ $DEBUG -eq 1 ] && env > /tmp/stopenv
  PRODUCT=$ID_MODEL_ID
  VENDOR=$ID_VENDOR_ID
  if [ -n "$ID_USB_DRIVER" ] && [ "$ID_IFACE" = "00" ] 
  then 
    PID="$(ps -eo pid,cmd |grep "pppd" |grep "$DEVNAME" |awk '{printf(" %s",$1)}')"
    [ -n "$PID" ] && kill -2 $PID  >/dev/null 2>&1 
    $LOGGER "$COMMAND $DEVNAME ${VENDOR}:$PRODUCT $ID_IFACE"
    rmmod $ID_USB_DRIVER
    leds -O orange &
  else
    [ $DEBUG -eq 1 ] && [ "$ID_IFACE" = "00" ] && $LOGGER "Failed $COMMAND $DEVICE ${VENDOR}:$PRODUCT"
  fi
}

case $COMMAND in
  start) start_pppd ;;
  stop) stop_pppd ;;
esac

exit 0

#set numeric output dor at+cops?
#at+cops=0,2
#show current operator <mode>,<format>,<oper> 3rd fiels is the operator
#at+cops? 
#
#cat /dev/ttyUSB0 >/tmp/test
#echo -e "AT+cops?\r" > /dev/ttyUSB0

